#ifndef property_traits_include
#define property_traits_include

namespace glas {

  template <class T>
  struct is_associative {
    static const bool value= false;
  };

  template <class T>
  struct is_associative<def::semiGroupAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::commSemiGroupAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::monoidAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::commMonoidAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::groupAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::abeleanGroupAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::semiGroupMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::commSemiGroupMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::monoidMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::commMonoidMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::groupMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_associative<def::abeleanGroupMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_commutative {
    static const bool value= false;
  };

  template <class T>
  struct is_commutative<def::commSemiGroupAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_commutative<def::commMonoidAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_commutative<def::abeleanGroupAdd<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_commutative<def::commSemiGroupMult<T> > {
    static const bool value= true;
  };

  template <class T>
  struct is_commutative<def::commMonoidMult<T> > {
    static const bool value= true;
  };
  
  template <class T>
  struct is_commutative<def::abeleanGroupMult<T> > {
    static const bool value= true;
    }; 
  
} // namespace glas

#endif // property_traits_include
